'''项目需求分析：
主程序类
显示
开启
关闭
坦克类：
坦克遇见墙壁不动
移动
发射
方向
显示
子弹类
#子弹遇见墙壁消失

移动
爆炸类
显示
墙类
是否通过属性
音乐类：
播放

'''
import pygame
import random
import time

from pygame.sprite import Sprite

SCREEN_WIDTH=800
SCREEN_HIGHT=500
fontColor=pygame.Color(255,0,0)
BG_COLOR=pygame.Color(0,0,0)
class Base(Sprite):
    def __init__(self, color, width, height):
        # Call the parent class (Sprite) constructor
        pygame.sprite.Sprite.__init__(self)


#游戏主程序
class MainGame():
    screen = None
    my_Tank = None
    #存储敌方坦克列表
    enemyTankList=[]
    #敌方坦克数量
    enemyTankCount=5
    #存储我方子弹列表
    myBulletList=[]
    #存储敌方子弹列表
    enemyBulletList=[]
    #存储爆炸列表
    explodeList=[]
    #存储抢列表
    WallList=[]
    def __init__(self):
        pass
  #开始游戏
    def startGame(self):
        # 初始化窗口
        pygame.display.init()

        # 显示窗口
        MainGame.screen=pygame.display.set_mode([SCREEN_WIDTH,SCREEN_HIGHT])
        #显示设置标题
        pygame.display.set_caption('坦克大战1.1')
        #将文字绘入surface blit（）画一个图像到另一个blit（source，dest，area = None，special_flags = 0）-> Rect在此Surface上绘制源Surface。可以使用dest参数定位平局。
        # 目标可以是代表源左上角的一对坐标。Rect也可以作为目标传递，矩形的左上角将用作blit的位置。目标矩形的大小不会影响blit。
        #初始化我方坦克
        self.createMyTank()

        #创建音乐
        muisc=Music('img/start.wav')
        muisc.play()
        #播放音乐
        # 初始化敌方坦克
        self.creatEnemyTank()
        while True:
            #填充窗口背景颜色
            time.sleep(0.02)
            MainGame.screen.fill(BG_COLOR)

            # 一直获取事件
            self.getEvent()
            MainGame.screen.blit(self.writeFont("敌方坦克剩余数量%d"%len(MainGame.enemyTankList)), (10, 10))
            #显示我方坦克
            #判断我方坦克是否存活，存活即显示
            if MainGame.my_Tank and MainGame.my_Tank.live:
                MainGame.my_Tank.displayTank()
            else:
                del MainGame.my_Tank
                MainGame.my_Tank=None

            #创建墙壁
            self.creatWall()
            #显示墙壁

            #显示敌方坦克，循环遍历
            self.blitEnemyTank()
            #显示我方子弹，循环遍历
            self.blitmyBullet()
            #显示敌方子弹，循环遍历
            self.blitEnemyBullet()
            #循环遍历爆炸显示
            self.blitExplode()
            if MainGame.my_Tank and MainGame.my_Tank.live:
                if not MainGame.my_Tank.stop:
                    MainGame.my_Tank.move()
                    MainGame.my_Tank.hit_Wall()
                    MainGame.my_Tank.myTank_hit_enemyTank()
            self.blitWall()
            #需要一直显示的方法都要放在更新方法之上，否则无法持续显示
            pygame.display.update()
    def createMyTank(self):
        MainGame.my_Tank = MyTank(350, 250)
    def creatWall(self):
        for i in range(6):
            wall=Wall(i*140,220)
            MainGame.WallList.append(wall)
    def blitWall(self):
        for wall in MainGame.WallList:
            if wall.live:
                wall.displayWall()
            else:
                MainGame.WallList.remove(wall)
    def creatEnemyTank(self):
        top = 100
        for i in range(MainGame.enemyTankCount):
            left=random.randint(0,600)
            speed=random.randint(1,4)
            enemy=enemyTank(left,top,speed)
            MainGame.enemyTankList.append(enemy)

    def blitEnemyBullet(self):
        for enemyBullet in MainGame.enemyBulletList:
            if enemyBullet.live:
                enemyBullet.displayBullet()
                enemyBullet.move()
                #调用敌方子弹和我方坦克相撞
                enemyBullet.enemyBullet_hit_myTank()
                #敌方子弹是否与墙壁碰撞
                enemyBullet.hitWall()
            else:
                MainGame.enemyBulletList.remove(enemyBullet)

    def blitEnemyTank(self):
        for enemyTank in MainGame.enemyTankList:
            if enemyTank.live:
                enemyTank.displayTank()
                enemyTank.randMove()
                enemyTank.enemyTank_hit_myTank()
                enemyTank.hit_Wall()
                # 创建敌方子弹
                enemyBullet=enemyTank.shot()
                #判断敌方子弹是否为空，不为空再存入列表中
                if  enemyBullet:
                    MainGame.enemyBulletList.append(enemyBullet)
            else:
                MainGame.enemyTankList.remove(enemyTank)
    def blitmyBullet(self):
        for myBullet in MainGame.myBulletList:
            if myBullet.live:
                myBullet.displayBullet()
                myBullet.move()
                myBullet.myBullet_hit_enemyTank()
                #我方子弹是否与墙壁碰撞
                myBullet.hitWall()
            else:
                MainGame.myBulletList.remove(myBullet)
    def blitExplode(self):
        for explode in MainGame.explodeList:
            if explode.live:
                explode.displayExplode()
            else:
                MainGame.explodeList.remove(explode)
    def writeFont(self,text):
        #初始化字体
        pygame.font.init()
        #查看字体类型pygame.font.get_fonts（）->字符串列表获取所有可用字体返回系统上所有可用字体的列表。
        #获取字体
        # pygame.font.SysFont（名称，大小，粗体= False，斜体= False）->字体根据系统字体创建一个Font对象
        font=pygame.font.SysFont("kaiti",18)
        #绘制文章信息render（文本，抗锯齿，颜色，背景=无）->表面。这将创建一个新的Surface，上面带有指定的文本。pygame无法提供在现有Surface上直接绘制文本的方法
        fontSurface=font.render(text,True,fontColor)
        return fontSurface
    def getEvent(self):
        eventList = pygame.event.get()
        for event in eventList:
            if event.type == pygame.QUIT:
                self.endGame()
            if event.type == pygame.KEYDOWN:#查看even的类型只有键盘统称
                if not MainGame.my_Tank:
                   if event.key==pygame.K_ESCAPE:
                       self.createMyTank()
                if MainGame.my_Tank and MainGame.my_Tank.live:
                    if event.key == pygame.K_DOWN:#键盘的对应值
                        MainGame.my_Tank.dirction="D"
                        MainGame.my_Tank.stop = False
                       # MainGame.my_Tank.move()
                    elif event.key == pygame.K_UP:
                        MainGame.my_Tank.dirction = "U"
                        MainGame.my_Tank.stop = False
                        #MainGame.my_Tank.move()
                    elif event.key == pygame.K_LEFT:
                        MainGame.my_Tank.dirction = "L"
                        MainGame.my_Tank.stop = False
                       # MainGame.my_Tank.move()
                    elif event.key == pygame.K_RIGHT:
                        MainGame.my_Tank.dirction = "R"
                        MainGame.my_Tank.stop =False
                        #MainGame.my_Tank.move()
                    elif event.key==pygame.K_SPACE:
                        #创建子弹
                        #子弹连发数量控制
                        if len(MainGame.myBulletList)<3:
                            myBullet=Bullet(MainGame.my_Tank)
                            MainGame.myBulletList.append(myBullet)
                            music=Music('img/fire.wav')
                            music.play()
            if event.type==pygame.KEYUP:
                if event.key == pygame.K_RIGHT or event.key == pygame.K_LEFT or event.key == pygame.K_DOWN or event.key == pygame.K_UP:
                    if MainGame.my_Tank and MainGame.my_Tank.live:
                        MainGame.my_Tank.stop=True





    #设置窗口背景 大小
    #循环持续显示
#结束游戏
    def endGame(self):
        exit()
        print("游戏结束")

class Tank(Base):
    def __init__(self,left,top):
        self.live=True
        self.speed=5
        self.stop=True
        #从文件加载新图像pygame.image.load（fileobj，namehint =“”）->表面
        #返回surface类型对象
        self.images = {'U':pygame.image.load("img/p1tankU.gif"),
                      'D':pygame.image.load("img/p1tankD.gif"),
                      'L': pygame.image.load("img/p1tankL.gif"),
                     'R':pygame.image.load("img/p1tankR.gif")}
        self.dirction='U'
        self.image=self.images[self.dirction]
        #获取surface的初始left top属性  pygame中surface.get_rect（左，上，宽，高）->矩形对象用于存储直角坐标矩形
        self.rect=self.image.get_rect()
        #设置left top值
        self.rect.left=left
        self.rect.top=top
        self.oldLeft=self.rect.left
        self.oldTop=self.rect.top
    def displayTank(self):
        #获取需要展示的对象
        self.image=self.images[self.dirction]
        #显示
        MainGame.screen.blit(self.image,self.rect)#or (self.left,self.top)
    def move(self):
        self.oldLeft=self.rect.left
        self.oldTop=self.rect.top
        if self.dirction=='U':
            if self.rect.top > 0:
                self.rect.top-=self.speed
        if self.dirction=='D':
            if self.rect.top+self.rect.height<SCREEN_HIGHT:
                self.rect.top+=self.speed
        if self.dirction=='R':
            if self.rect.left+self.rect.height<SCREEN_WIDTH:
                self.rect.left+=self.speed
        if self.dirction=='L':
            if self.rect.left>0:
                self.rect.left-=self.speed
    def shot(self):
      return  Bullet(self)
    def hit_Wall(self):
        for wall in MainGame.WallList:
            if pygame.sprite.collide_rect(wall,self):
                self.stay()
                # 创建碰撞音乐

    def stay(self):
        self.rect.left=self.oldLeft
        self.rect.top=self.oldTop

class MyTank(Tank):
    def __init__(self,left,top):
        super(MyTank,self).__init__(left,top)
    def myTank_hit_enemyTank(self):
        for enemyTank in MainGame.enemyTankList:
            if pygame.sprite.collide_rect(self,enemyTank):
                self.stay()
                # 创建碰撞音乐
                music = Music('img/hit.wav')
                # 播放音乐
                music.play()
class enemyTank(Tank):
    def __init__(self,left,top,speed):
        super(enemyTank,self).__init__(left,top)
        self.images={'U':pygame.image.load('img/enemy1U.gif'),
                     'D': pygame.image.load('img/enemy1D.gif'),
                     'L': pygame.image.load('img/enemy1L.gif'),
                     'R': pygame.image.load('img/enemy1R.gif')}
        self.dirction=self.randomDirction()
        self.image=self.images[self.dirction]
        self.rect=self.image.get_rect()
        self.rect.left=left
        self.rect.top=top
        self.speed=speed
        self.stop=True
        self.step=60
    def randMove(self):
        if self.step<=0:
            self.dirction=self.randomDirction()
            self.step=60
        else:
            self.move()
            self.step-=1

    def enemyTank_hit_Wall(self):
        for wall in MainGame.WallList:
            if pygame.sprite.collide_rect(wall,self):
                enemyTank.stay()
    def enemyTank_hit_myTank(self):
        if MainGame.my_Tank and MainGame.my_Tank.live:
            if pygame.sprite.collide_rect(MainGame.my_Tank,self):
                self.stay()

    def randomDirction(self):
        num=random.randint(1,4)
        if num==1:
            return 'U'
        if num==2:
            return 'D'
        if num==3:
            return'L'
        if num==4:
            return'R'

    def shot(self):
        num=random.randint(1,200)
        if num<10:
            return Bullet(self)

class Bullet(Base):
    def __init__(self,tank):
        self.speed=5
        self.live=True
        #获取图片
        self.image=pygame.image.load('img/enemymissile.gif')
        #坦克的方向决定子弹的方向
        self.direction=tank.dirction
        self.rect=self.image.get_rect()
        #tank的位置决定子弹的位置
        if self.direction == 'U':
            self.rect.left = tank.rect.left + tank.rect.width / 2 - self.rect.width / 2
            self.rect.top = tank.rect.top - self.rect.height
        elif self.direction == 'D':
            self.rect.left = tank.rect.left + tank.rect.width / 2 - self.rect.width / 2
            self.rect.top = tank.rect.top + tank.rect.height
        elif self.direction == 'L':
            self.rect.left = tank.rect.left - self.rect.width / 2 - self.rect.width / 2
            self.rect.top = tank.rect.top + tank.rect.width / 2 - self.rect.width / 2
        elif self.direction == 'R':
            self.rect.left = tank.rect.left + tank.rect.width
            self.rect.top = tank.rect.top + tank.rect.width / 2 - self.rect.width / 2
    def move(self):

        if self.direction=='U':
            if self.rect.top > 0:
                self.rect.top-=self.speed
            else:
                self.live =False
        if self.direction=='D':
            if self.rect.top+self.rect.height<SCREEN_HIGHT:
                self.rect.top+=self.speed
            else:
                self.live = False
        if self.direction=='R':
            if self.rect.left+self.rect.width<SCREEN_WIDTH:
                self.rect.left+=self.speed
            else:
                self.live = False
        if self.direction=='L':
            if self.rect.left>0:
                self.rect.left-=self.speed
            else:
                self.live = False

    def displayBullet(self):
        MainGame.screen.blit(self.image,self.rect)
    def myBullet_hit_enemyTank(self):
        if MainGame.my_Tank and MainGame.my_Tank.live:
            for enemyTank in MainGame.enemyTankList:
                #pygame.sprite.collide_rect（左，右）->布尔使用rects检测两个精灵之间的碰撞。
                if pygame.sprite.collide_rect(enemyTank,self):
                    self.live=False
                    enemyTank.live=False
                    #创建爆炸
                    explode=Explode(enemyTank)
                    #存储到爆炸列表中
                    MainGame.explodeList.append(explode)
                    # 创建碰撞音乐
                    music = Music('img/fire.wav')
                    # 播放音乐
                    music.play()
    def enemyBullet_hit_myTank(self):
        if MainGame.my_Tank and MainGame.my_Tank.live:
            if pygame.sprite.collide_rect(MainGame.my_Tank, self):
                self.live = False
                MainGame.my_Tank.live = False
                #创建爆炸
                explode=Explode(MainGame.my_Tank)
                MainGame.explodeList.append(explode)
                # 创建碰撞音乐
                music = Music('img/fire.wav')
                # 播放音乐
                music.play()


    #将保障存储到列表
    #更改子弹和坦克状态

    def hitWall(self):
        for wall in MainGame.WallList:
            if pygame.sprite.collide_rect(self,wall):
                self.live=False
                wall.hp-=1
                #减生命值时判断数值大小，确定墙壁的生存状态。主要逻辑，条件嵌套还是并列
                if wall.hp<=0:
                    wall.live=False
class Explode():
    def __init__(self,tank):
        #炮炸的位置由坦克的位置决定
        self.rect=tank.rect
        self.images=[pygame.image.load("img/blast0.gif"),
                     pygame.image.load("img/blast1.gif"),
                     pygame.image.load("img/blast2.gif"),
                     pygame.image.load("img/blast3.gif"),
                     pygame.image.load("img/blast4.gif")]
        self.step=0
        self.image=self.images[self.step]
        self.live=True
    def displayExplode(self):
        #根据索引获取爆炸对象
        if self.step<len(self.images):
            self.image = self.images[self.step]
            self.step+=1
            MainGame.screen.blit(self.image,self.rect)
        else:
            self.live=False
            self.step=0

class Wall():
    def __init__(self,left,top):
        self.image=pygame.image.load("img/steels.gif")
        self.rect=self.image.get_rect()
        self.rect.left=left
        self.rect.top=top
        self.live=True
        self.hp=3
    def displayWall(self):
        MainGame.screen.blit(self.image,self.rect)

class Music():
    def __init__(self,filename):
        self.filename=filename
        #初始化音乐混合器
        pygame.mixer.init()
        pygame.mixer.music.load(self.filename)
    def play(self):
        pygame.mixer.music.play()
if __name__=='__main__':
    MainGame().startGame()